TREEVIEW: Vertical rollover feature: assure TREEVIEW is compatible with MS Treeview control

04/23/2021 09:19 AM - Vladimir Tsichevski

Status: Test Start date:  
Category:  Estimated time: 0.00 hour

Target version:    
Description

Related issues:

Related to User Interface - Bug #5118: TREELIST widget issues WIP

History

#1 - 04/23/2021 09:20 AM - Vladimir Tsichevski

The problem:

There is a feature of existing TREEVIEW implementation in FWD: if a TREEVIEW is navigated with keyboard past the last tree node, the selection

jumps to the first tree node. And vice-versa: if a TREEVIEW is navigated with keyboard before the first tree node, the selection jumps to the last tree

node.

The TREEVIEW was modeled after the MS Treeview control, hence the TREEVIEW behavior should match that of the control.

At the moment of writing, it is unclear, if this feature exist in original MS Treeview control, so this needs to be discovered using a native MS

environment, and we need to assure the TREEVIEW implementation matches that of MS Treeview control in this respect.

#3 - 05/19/2021 03:12 PM - Vladimir Tsichevski

- Related to Bug #5118: TREELIST widget issues added

#4 - 06/30/2021 02:52 PM - Greg Shah

- Assignee set to Vladimir Tsichevski

#5 - 06/30/2021 04:02 PM - Greg Shah

- Assignee deleted (Vladimir Tsichevski)

#6 - 09/01/2021 03:16 PM - Vladimir Tsichevski

- % Done changed from 0 to 100

- Status changed from New to WIP

Tested: the roll-over feature does not exist in MS TreeView.

Fixed in FWD 3821c rev. 12882
#7 - 09/01/2021 03:16 PM - Vladimir Tsichevski

- Status changed from WIP to Review

#8 - 09/02/2021 08:59 AM - Greg Shah

Vladimir: We generally don't add random features.  Why was the feature there if it is not needed?  I'm worried that it is needed in some use case that

customer code will hit.

Hynek: Please review.

#9 - 09/02/2021 09:24 AM - Vladimir Tsichevski

Greg Shah wrote:

Vladimir: We generally don't add random features.  Why was the feature there if it is not needed?  I'm worried that it is needed in some use case

that customer code will hit.

Hynek: Please review.

 

This came to my mind either, but I did not found any way to make MS TreeView roll-over. In any case, if we will want to enable this feature, we will

need to make it configurable as some FWD extension, that means do change the previous implementation, since neither TREEVIEW OCX, nor

TREELIST OCX support this feature.

#10 - 09/02/2021 10:14 AM - Greg Shah

Eugenie: Could this code have been used in that customer-specific OCX replacement from #3822?

#11 - 09/02/2021 10:43 AM - Eugenie Lyzenko

Greg Shah wrote:

Eugenie: Could this code have been used in that customer-specific OCX replacement from #3822?

 

Do you mean if we have some non-standard customer specific feature of OCX control - can we convert them by the same approach that used for the

object discussed in #3822?

#12 - 09/02/2021 10:49 AM - Greg Shah

Eugenie: Could this code have been used in that customer-specific OCX replacement from #3822?
Do you mean if we have some non-standard customer specific feature of OCX control - can we convert them by the same approach that used for

the object discussed in #3822?

 

No, I'm asking if the code removed in 3821c rev 12882 was inserted originally by you for usage in #3822?  Doesn't the replacement widget in #3822

use the TREEVIEW code internally?

#13 - 09/02/2021 10:58 AM - Eugenie Lyzenko

Greg Shah wrote:

Eugenie: Could this code have been used in that customer-specific OCX replacement from #3822?

 

Do you mean if we have some non-standard customer specific feature of OCX control - can we convert them by the same approach that

used for the object discussed in #3822?

 

No, I'm asking if the code removed in 3821c rev 12882 was inserted originally by you for usage in #3822?

 

No. I did not add this code.

Doesn't the replacement widget in #3822 use the TREEVIEW code internally?

 

Yes, the new widget acts like TREELIST in all places where it does not need specific processing.
#14 - 09/02/2021 11:42 AM - Vladimir Tsichevski

Eugenie Lyzenko wrote:

Doesn't the replacement widget in #3822 use the TREEVIEW code internally?

 

Yes, the new widget acts like TREELIST in all places where it does not need specific processing.

 

I think, Eugenie meant no, the FWD implementation in #3822 is based on TREELIST, not on TREEVIEW.

AFAIK, TREEVIEW is not used in this customer project.

#15 - 09/02/2021 11:52 AM - Eugenie Lyzenko

Vladimir Tsichevski wrote:

Eugenie Lyzenko wrote:

Doesn't the replacement widget in #3822 use the TREEVIEW code internally?

 

Yes, the new widget acts like TREELIST in all places where it does not need specific processing.

 

I think, Eugenie meant no, the FWD implementation in #3822 is based on TREELIST, not on TREEVIEW.

AFAIK, TREEVIEW is not used in this customer project.

 

Yes, you are right. TREELIST is a different object. Sorry for confusion. The widgets can cross on the common base TreeWidgetBase implementation

methods.
#16 - 09/03/2021 06:22 AM - Hynek Cihlar

Code review 3821c revision 12882. The changes are OK.

#17 - 09/03/2021 07:59 AM - Greg Shah

- Status changed from Review to Test

- Assignee set to Vladimir Tsichevski
